% Financial Engineering Toolbox.
% Version 2.5.1
% Copyright (c) 1996-98 by Rafal Weron.
%
% Option pricing models.
%   bsvalue  - The Black-Scholes (1973) model: European options on stocks.
%   bvalue   - The Black (1976) model: European options on futures.
%
% "Greek pages" - changing market indicators.
%   bgreek   - The Black (1976) model: European options on futures.
%
% Profit/Loss graphs.
%   position - Profit/loss graph of underlying assets and options position.
%
% Utility routines.
%   stdstr   - Function for standardizing strings.
%   helpfn   - Function for displaying help text. 
%
% Demonstration programs.
%   findemo  - Financial Engineering Toolbox v. 2.0 Demo.

% Internally used utility routines.
%   binary   - Decimal to binary conversion.
%   change   - Utility function used in PART6.
%   exotic   - Price exotic options.
%   gpf      - Former Matlab demo utility function; needed to run FET under Matlab 7. 
%   greek3   - 3D "greek pages" in the Black (1976) model.
%   mesh2    - Linear mesh.
%   part*    - Part of FINDEMO.
%   payout   - Exotic option payout.
%   pos3     - 3D profit/loss graph of underlying assets and options position.
%   posvalue - Value of a position at a given price.
%   price    - Recursive function.
%   quantile - Calulate quantiles.
%   switch2  - Switch figures.
%   text2    - Add text to the current plot.
%   traject  - Binomial tree trajectories.
%   tree     - Plot a prices tree.
