function part5(action)
%PART5 Internally used by FINDEMO.

% Copyright (c) 1996-98 by Rafal Weron.
% Written by: J. Glowinski, M. Grot, R. Weron.
 
global FIGURE COLOR TYPE TYPE1 S0 T N R U D X FF GG C0;
 
if nargin==0
  action='init';
end
 
if strcmp(action,'init')
  set(FIGURE(5),'visible','off');

  FIGURE=switch2(FIGURE,1);
  pos=get(FIGURE(1),'position');
  set(FIGURE(1),'resize','off',...
                'position',[pos(1) pos(2) 360 410],...
                'color',COLOR,...
                'menubar','none',...
                'numbertitle','off',...
                'name','Exotic options (recursive)');
  clf;

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[40 310 130 20],...
            'string','PARAMETERS');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 270 30 20],...
            'string','So=');
  S0=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
            'position',[90 270 70 20],...
            'string','100');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 250 30 20],...
            'string','u=');
  U=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
            'position',[90 250 70 20],...
            'string','1.1');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 230 30 20],...
            'string','d=');
  D=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
            'position',[90 230 70 20],...
            'string','0.9');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 210 30 20],...
            'string','n=');
  N=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
            'position',[90 210 70 20],...
            'string','5');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 190 30 20],...
            'string','T=');
  T=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
            'position',[90 190 70 20],...
            'string','365');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 170 30 20],...
            'string','r=');
  R=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
            'position',[90 170 70 20],...
            'string','10');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[190 310 130 20],...
            'string','OPTION TYPE');
  TYPE=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
            'position',[200 270 120 20],...
  	    'string','LOOKBACK|BARRIER|AVERAGE RATE|GEOMETRIC|OTHER',...
            'value',1,...
            'callback','part5(''type'')');
  TYPE1=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
            'position',[200 230 120 20],...
  	    'string','CALL|PUT',...
            'value',1,...
            'callback','part5(''type'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[190 180 130 20],...
            'string','OPTION PRICE');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[200 140 30 20],...
            'string','X=');
  X=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[240 140 70 20]);
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[40 360 70 20],...
            'string','RUN',...
            'callback','part5(''run'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[130 360 70 20],...
            'string','HELP',...
            'callback','part5(''help'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[220 360 70 20],...
            'string','EXIT',...
            'callback','part5(''exit'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[40 100 130 20],...
            'string','PAYOUT FORMULA');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[40 70 80 20],...
            'string','f(c,s)=');
  FF=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
            'position',[130 70 200 20],...
            'string','min(c,s)');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[40 40 80 20],...
            'string','g(C,s)=');
  GG=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
            'position',[130 40 200 20],...
            'string','max(0,s-C)');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[80 10 40 20],...
            'string','Co=');
  C0=...
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
            'position',[130 10 40 20],...
            'string','So');


elseif strcmp(action,'type')
  type=get(TYPE,'value');
  type1=get(TYPE1,'value');
  if type==1
    if type1==1
       set(GG,'string','max(0,s-C)');
       set(FF,'string','min(c,s)'); 
       set(C0,'string','So');
    else
       set(GG,'string','max(0,C-s)');
       set(FF,'string','max(c,s)'); 
       set(C0,'string','So');
    end
  elseif type==2 
    if type1==1
       set(GG,'string','C*max(0,s-100)');
       set(FF,'string','(s<150)*c'); 
       set(C0,'string','1');
    else
       set(GG,'string','C*max(0,100-s)');
       set(FF,'string','(s>70)*c'); 
       set(C0,'string','1');
    end
  elseif type==3
    if type1==1
       set(GG,'string','max(C/(N_+1)-100,0)');
       set(FF,'string','c+s'); 
       set(C0,'string','0');
    else
       set(GG,'string','max(100-C/(N_+1),0)');
       set(FF,'string','c+s'); 
       set(C0,'string','0');
    end
  elseif type==4
    if type1==1 
       set(GG,'string','max(C^(1/(N_+1))-100,0)');
       set(FF,'string','c*s'); 
       set(C0,'string','1');
    else
       set(GG,'string','max(100-C^(1/(N_+1)),0)');
       set(FF,'string','c*s'); 
       set(C0,'string','1');
    end
  else
    set(GG,'string','');
    set(FF,'string',''); 
    set(C0,'string','');
  end 

elseif strcmp(action,'run')
  So=str2num(get(S0,'string'));
  u=str2num(get(U,'string'));
  d=str2num(get(D,'string'));
  n=str2num(get(N,'string'));
  t=str2num(get(T,'string'));
  r=str2num(get(R,'string'));

  ff=get(FF,'string');
  gg=get(GG,'string'); 
  co=get(C0,'string');

  x=exotic(So,u,d,n,t,r,ff,gg,co);

  set(X,'string',num2str(x));

elseif strcmp(action,'help')
  page1=...
    ['RUN                                                   '
     '  calculate the option price;                         '
     'HELP                                                  '
     '  this help window;                                   '
     'EXIT                                                  '
     '  return to FINDEMO;                                  '
     'PARAMETERS                                            '
     '  So - underlying instrument price at time 0;         '
     '  u,d - up, down jump given in a multiplicative       '
     '    (Su=S*u, e.g. u=1.1, d=0.9) way only;             '
     '  n - number of price jumps to maturity;              '
     '  T - time to option maturity (in days);              '
     '  r - annual interest rate (in percent);              '
     'OPTION TYPE                                           '
     '  select asian (average rate, geometric), barrier,    '
     '  lookback or other (user defined by the PAYOUT       '
     '  FORMULA) options; all options can be either calls   '
     '  or puts;                                            '
     'PAYOUT FORMULA                                        '
     '  user defined functions; syntax is described in:     '
     '  A. Weron and R. Weron, "Financial Engineering",     '
     '  WNT, Warsaw, 1998;                                  '
     'OPTION PRICE                                          '
     '  binomial price of the specified option;             '];

  page2=...
    ['RUN                                                   '
     '  rozpoczecie obliczen;                               '
     'HELP                                                  '
     '  pomoc;                                              '
     'EXIT                                                  '
     '  powrot do FINDEMO;                                  '
     'PARAMETERS                                            '
     '  So - cena instrumentu podstawowego w chwili 0;      '
     '  u,d - skok w gore, dol; zdefiniowany w sposob       '
     '    multiplikatywny (Su=S*u, e.g. u=1.1, d=0.9);      '
     '  n - liczba krokow do terminu wygasniecia;           '
     '  T - termin wygasniecia opcji (w dniach);            '
     '  r - roczna stopa procentowa (w procentach);         '
     'OPTION TYPE                                           '
     '  rodzaj opcji (kupna lub sprzedazy): azjatycka       '
     '  (average rate, geometric), barierowa, lookback lub  '
     '  inna zdefiniowana przez uzytkownika w polu          '
     '  PAYOUT FORMULA;                                     '
     'PAYOUT FORMULA                                        '
     '  funkcja wyplaty; skladnia jest opisana w ksiazce:   '
     '  A. Weron i R. Weron, "Inzynieria finansowa",        '
     '  WNT, Warszawa, 1998;                                '
     'OPTION PRICE                                          '
     '  wyliczona cena opcji egzotycznej;                   '];

  buttonStr=['English';
             'Polski ';
             '       '];
  helpfn('Exotic options (recursive)',buttonStr,page1,page2);
  pos=get(gcf,'position');
  set(gcf,'name','Help',...
    'position',[pos(1) pos(2) 450 380],...
    'resize','off',...
    'menubar','none');

elseif strcmp(action,'exit')
  list=get(0,'children');
  for i=1:length(list),
    if list(i)~=FIGURE(5)
      close(list(i));
    end
  end
  set(FIGURE(5),'visible','on');
  clear global TYPE TYPE1 S0 T N R U D X FF GG C0;
end
