function payout(action,S1,k,o_type,m_size,up,down);
%PAYOUT Internally used by PART6.

% Copyright (c) 1996-98 by Rafal Weron.
% Written by: M. Orzeszyna, R. Weron, L. Wojakowski.

global  EXPERIM_RES;

if strcmp(action,'call')
  if o_type==1 			% european call
    if m_size==2
      EXPERIM_RES=mean(max(S1-k,0));
    else
      EXPERIM_RES=max(S1-k,0);
    end;	
  elseif o_type==2		% corridor knock-out call
    s_point=size(S1);
    for i=1:s_point(1)
      if S1(i,1)<up &S1(i,1)>down
        a =find(S1(i,:)>=up); 	
	aa=find(S1(i,:)<=down);	
	if a==[]
	  a=s_point(2)+1;
	end;
	if aa==[]
	  aa=s_point(2)+1;
	end;
	a=min(a(1),aa(1));
      else
        a=1;
      end;
      if a~=s_point(2)+1;
        S1(i,a:s_point(2))=zeros(1,s_point(2)-a+1);	
      end;
    end;
    S1=max(S1-k,0);
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=S1;
    end;	
  elseif o_type==3			% lookback #1 call
    a = zeros(size(S1));
    a(:,1)=S1(:,1);
    h=size(S1);
    for i=2:h(2)
      a(:,i)=min(S1(:,1:i)')';
    end;
    S1=S1-a;
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=S1;
    end;	
  elseif o_type==4			% lookback #2 call
    a = zeros(size(S1));
    a(:,1)=S1(:,1);
    h=size(S1);
    for i=2:h(2)
      a(:,i)=min(S1(:,1:i)')';
    end;
    S1=S1-up*a;
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=S1;
    end;	
  elseif o_type==5			% modified lookback call
    a = zeros (size (S1));
    a(:,1)=S1(:,1);
    h=size(S1);
    for i=2:h(2)
      a(:,i)=max(S1(:,1:i)')';
    end;
    S1=max(a-k,0);
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=S1;
    end;	
  elseif o_type==6			% average rate call
    a = zeros (size (S1));
    if up==1
      a(:,1)=S1(:,1);
      h=size(S1);
      for i=2:h(2)
        a(:,i)=(a(:,i-1)+S1(:,i)/(i-1))*(i-1)/i;
      end;	
    elseif up==2
      a(:,1)=S1(:,1);
      h=size(S1);
      for i=2:h(2)
        a(:,i)=(a(:,i-1).*(S1(:,i).^(1/(i-1)))).^((i-1)/i);
      end;
    end;
    S1=max(a-k,0);
    if m_size==2
      EXPERIM_RES=mean((S1));
    else
      EXPERIM_RES=S1;
    end;	
  elseif o_type==7			% average strike call
    a = zeros (size (S1));
    if up==1
      a(:,1)=S1(:,1);
      h=size(S1);
      for i=2:h(2)
        a(:,i)=(a(:,i-1)+S1(:,i)/(i-1))*(i-1)/i;
      end;	
    elseif up==2
      a(:,1)=S1(:,1);
      h=size(S1);
      for i=2:h(2)
        a(:,i)=(a(:,i-1).*(S1(:,i).^(1/(i-1)))).^((i-1)/i);
      end;
    end;
    S1=max(S1-a,0);
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=(S1);
    end;	
  end;
elseif strcmp(action,'put')
  if o_type==1				
    if m_size==2 			% european put
      EXPERIM_RES=mean(max(k-S1,0));
    else
      EXPERIM_RES=max(k-S1,0);
    end;
  elseif o_type==2			% corridor knock-out put
    s_point=size(S1);
    for i=1:s_point(1)
      if S1(i,1)<up &S1(i,1)>down
        a =find(S1(i,:)>=up); 	
	aa=find(S1(i,:)<=down);	
	if a==[]
	  a=s_point(2)+1;
	end;
	if aa==[]
	  aa=s_point(2)+1;
	end;
	a=min(a(1),aa(1));
      else
        a=1;
      end;
      if a~=s_point(2)+1;
        S1(i,a:s_point(2))=ones(1,s_point(2)-a+1)*k;	
      end;
    end;
    S1=max(k-S1,0);
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=S1;
    end;	
  elseif o_type==3			% lookback #1 put
    a = zeros (size (S1));
    a(:,1)=S1(:,1);
    h=size(S1);
    for i=2:h(2)
      a(:,i)=max(S1(:,1:i)')';
    end;
    S1=a-S1;
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=S1;
    end;
  elseif o_type==4			% lookback #2 put
    a = zeros (size (S1));
    a(:,1)=S1(:,1);
    h=size(S1);
    for i=2:h(2)
      a(:,i)=max(S1(:,1:i)')';
    end;
    S1=max(0,up*a-S1);
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=S1;
    end;
  elseif o_type==5			% modified lookback put
    a = zeros (size (S1));
    a(:,1)=S1(:,1);
    h=size(S1);
    for i=2:h(2)
      a(:,i)=min(S1(:,1:i)')';
    end;
    S1=max(k*ones(size(a))-a,0);
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=S1;
    end;	
  elseif o_type==6			% average rate put
    a = zeros (size (S1));
    if up==1			
      a(:,1)=S1(:,1);
      h=size(S1);
      for i=2:h(2)
        a(:,i)=(a(:,i-1)+S1(:,i)/(i-1))*(i-1)/i;
      end;	
    elseif up==2
      a(:,1)=S1(:,1);
      h=size(S1);
      for i=2:h(2)
        a(:,i)=(a(:,i-1).*(S1(:,i).^(1/(i-1)))).^((i-1)/i);
      end;
    end;
    S1=max(-a+k,0);
    if m_size==2
      EXPERIM_RES=mean((S1));
    else
      EXPERIM_RES=S1;
    end;
  elseif o_type==7			% average strike put
    a = zeros (size (S1));
    if up==1			
      a(:,1)=S1(:,1);
      h=size(S1);
      for i=2:h(2)
        a(:,i)=(a(:,i-1)+S1(:,i)/(i-1))*(i-1)/i;
      end;
    elseif up==2
      a(:,1)=S1(:,1);
      h=size(S1);
      for i=2:h(2)
        a(:,i)=(a(:,i-1).*(S1(:,i).^(1/(i-1)))).^((i-1)/i);
      end;
    end;
    S1=max(a-S1,0);
    if m_size==2
      EXPERIM_RES=mean(S1);
    else
      EXPERIM_RES=S1;
    end;	
  end;
end;

