function tree2(titlestr,paramstr,n,array,mode,trace)
%TREE2 Internally used by FINDEMO.

% mode==1 gives the slow motion (and reverse display)

% Copyright (c) 1996 by Rafal Weron.
% Written by: J. Glowinski, R. Weron.

set(axes,'position',[0 0 1 0.85],'visible','off');
axis([-0.5 n+0.5 -n-0.5 n+0.5]);
pos=get(gcf,'position');
text2((pos(3)-10*length(titlestr))/2,400,titlestr);
text2((pos(3)-7*length(paramstr))/2,380,paramstr);
h=line([0 n],[0 -n]);
set(h,'color',[1 0 0]);
for i=1:n-1,
  h=line([i n],[i -n+2*i]);
  set(h,'color',[1 0 0]);
end
h=line([0 n],[0 n]);
set(h,'color',[1 0 0]);
for i=1:n-1,
  h=line([i n],[-i n-2*i]);
  set(h,'color',[1 0 0]);
end

if nargin>5       % 'trace' a given path 
  x=0;
  y=0;
  for l=1:n,
    if trace(l)==1
      h=line([x x+1],[y y+1]);
      set(h,'color',[1 1 1]);
      y=y+1;
    else
      h=line([x x+1],[y y-1]);
      set(h,'color',[1 1 1]);
      y=y-1;
    end
    x=x+1;
  end
end

f_size = 13 - n;

for i=0:n,
  for j=0:i,
    pos=(i+1)*i/2+j+1;
    x=i-0.25;
    y=i-2*j-0.25;
    hp(pos)=patch([x x+0.5 x+0.5 x x],[y y y+0.5 y+0.5 y],'b');
    set(hp(pos),'edgecolor',[0 0 1]);
    x=i-0.2;
    y=i-2*j;
    ht(pos)=text(x,y,num2str(array(pos)));
    set(ht(pos),'fontsize',f_size,'color',[1 1 1]);
    if mode==1, 
       set(ht(pos),'visible','off');
    else 
       set(ht(pos),'visible','on');
    end
  end
end

if mode==1
  vector=n:-1:0;
  for i=vector,
    pause(2);
    pos=(i+1)*i/2+1+(0:i);
    set(hp(pos),'facecolor',[0 0 1],'edgecolor',[0 0 1]);
    set(ht(pos),'fontsize',f_size,'color',[1 1 1]);
    set(ht(pos),'visible','on');
  end
end

